function [freq, amp, phase]=ampphase(X,fmax)

%[freq, amp, phase]=ampphase(X,fmax) eller [freq, amp, phase]=ampphase(X)   SPHAND=SPECTMOD(X,AP,fmax) eller SPECTMOD(X,AP): 
% Returnerar frekvens-, amplitudbelopp och fas till 
% fouriertransformen/laplacetransformen X
%
% Lasse Alfredsson, oktober 1997

global pm1 pm2 pm3 pm4 KlabL
if vtype(X)==5		% Fouriertransform, X(w)
  	f=X(KlabL+2)*(0:(KlabL/2-1));
  	if nargin==1, fmax=X(KlabL+1)/2; end
  	if fmax>X(KlabL+1)/2, fmax=X(KlabL+1)/2; end
	b=find(f<=fmax);
	f=f(b);
	X=X(b);
else			% Laplacetransform, X(s)
	if nargin==1,
		fmax=bandwi(X);
		if fmax==inf, fmax=200; end
	end
	f=(0:512)*fmax/512;
	Xt=X(1,3)*poly(X(1,4:3+X(1,2)));
	Xn=X(2,3)*poly(X(2,4:3+X(2,2)));
	X=polyval(Xt,j*2*pi*f)./polyval(Xn,j*2*pi*f);
end

freq=f;
amp=abs(X);
fi=180/pi.*angle(X);
a=find(fi>0);
fi(a)=fi(a)-360;
phase=fi;
