function buttchebdem(buttnr)

% Analys av Butterworth- och Chebyshev I-filter (LP-typ) av olika gradtal
%
% OBS! OBS! Fr Chebyshev-filter anvnds funktionen CHEBY1,
%           som finns i Signal Processing Toolbox!!!!
%
% Lasse Alfredsson, Oktober 1997

global AX BUTT FILT POL AMPLOT GRLP

if nargin==0	% Forsta anropet
  axesdef(6,'Butterworth- och Chebyshevfilter: ndra filtertyp och gradtal');
  uimenu('Label','            ');
  fom = uimenu('Label','Brja om !!');
  	uimenu(fom, 'Label','G till KRETSDEMO', 'callback','clf, kretsdemo(1)');
        uimenu(fom, 'Label','Passiva filter-demo igen', 'callback','buttchebdem');


BUTT(1)=uicontrol('units','normal','pos',[.14 .8 .1 .08], ...
		'style','popup', ...
		'string','n=0|n=1|n=2|n=3|n=4|n=5|n=6|n=7|n=8|n=9', ...
		'fontsize',14, ...
		'backgroundcolor','blue','foregroundcolor','black', ...
		'callback','buttchebdem(1)');

BUTT(2)=uicontrol('units','normal','pos',[.28 .8 .1 .08], ...
		'style','popup', ...
		'string','n=0|n=1|n=2|n=3|n=4|n=5|n=6|n=7|n=8|n=9', ...
		'fontsize',14, ...
		'backgroundcolor','red','foregroundcolor','black', ...
		'callback','buttchebdem(2)');

FILT(1)=uicontrol('Units','normal', ...
	'Position',[.07 .9 .17 .05], ...
	'FontSize',14, ...
	'String','Butterworth|Chebyshev I', ...
	'Style','popup', ...
	'backgroundcolor','blue','foregroundcolor','black', ...
	'callback','buttchebdem(3)');

FILT(2)=uicontrol('Units','normal', ...
	'Position',[.28 .9 .17 .05], ...
	'FontSize',14, ...
	'String','Butterworth|Chebyshev I', ...
	'Style','popup', ...
	'backgroundcolor','red','foregroundcolor','black', ...
	'callback','buttchebdem(4)');


uicontrol('Units','normal', ...
	'BackgroundColor',get(gcf,'color'), ...
	'FontSize',16, ...
	'fontname','times', ...
	'Position',[.02 .03 .48 .1], ...
	'String','Pol-nollstllediagram', ...
	'Style','text');

uicontrol('units','normal','pos',[.06 .83 .055 .04], ...
		'style','pushbutton', ...
		'string','|H(s)|', ...
		'fontsize',12, ...
		'backgroundcolor','blue','foregroundcolor','black', ...
		'callback','global BUTT FILT, val=get(BUTT(1),''value'')-1; if val>0, if get(FILT(1),''value'')==1, Htmp=butterw(val);else, [b,a]=cheby1(val,3,2*pi,''s''); Htmp=in(b,a,''s'');end,figure(''Position'',[-2 2 804 562]), splane(Htmp); end');

uicontrol('units','normal','pos',[.4 .83 .055 .04], ...
		'style','pushbutton', ...
		'string','|H(s)|', ...
		'fontsize',12, ...
		'backgroundcolor',[1 0 0],'foregroundcolor',[0 0 0], ...
		'callback','global BUTT FILT, val=get(BUTT(2),''value'')-1; if val>0, if get(FILT(2),''value'')==1, Htmp=butterw(val);else, [b,a]=cheby1(val,3,2*pi,''s''); Htmp=in(b,a,''s'');end,figure(''Position'',[-2 2 804 562]), splane(Htmp); end');


axes(AX(1,1))
t=0:.01:2*pi;
plot(2*pi*sin(t),2*pi*cos(t),'k:','linewidth',0.5)
hold on
for a=1:10
   POL(1,a)=plot(0,0,'bx','EraseMode','xor','linewidth',2, ...
		'MarkerSize',12,'visible','off');
   POL(2,a)=plot(0,0,'rx','EraseMode','xor','linewidth',2, ...
		'MarkerSize',12,'visible','off');
end
grid
axis([-7 7 -7 7])
set(AX(1,1),'fontsize',14)
set(AX(1,1),'xtick',[-6.3 -4 -2 0 2 4 6.3])
set(AX(1,1),'ytick',[-6.3 -4 -2 0 2 4 6.3])



axes(AX(1,2))
Htmp=butterw(1);
[freq,amp,pha]=ampphase(Htmp,2.5);
AMPLOT(1)=plot(freq,amp,'b','EraseMode','xor','linewidth',2, ...
		'visible','off');
hold on
AMPLOT(2)=plot(freq,amp,'r','EraseMode','xor','linewidth',2, ...
		'visible','off');
axis([0 2.5 0 1.1])
grid
set(AX(1,2),'fontsize',14)
set(AX(1,2),'xtick',[0 0.5 1 1.5 2 2.5])
set(AX(1,2),'ytick',[0 0.25 0.5 0.707 1])
title('Amplitudkaraktristik, |H(f)|','fontsize',14)
xlabel('Frekvens,  (f Hz)     Grnsfrekvens f_0=1 Hz','fontsize',14)

axes(AX(2,2))
lth=length(pha);

GRLP(1)=plot(freq(1:lth-1),-2*pi*diff(pha)./diff(freq),'b', ...
		'EraseMode','xor','linewidth',2,'visible','off');
hold on
GRLP(2)=plot(freq(1:lth-1),-2*pi*diff(pha)./diff(freq),'r', ...
		'EraseMode','xor','linewidth',2,'visible','off');

axis([0 2.5 0 4])
grid
set(AX(2,2),'fontsize',14)
set(AX(2,2),'xtick',[0 0.5 1 1.5 2 2.5])
set(AX(2,2),'ytick',[0 1 2 3 4])
title('Grupplptiden,  ( t_g = -d/d\omega\{arg(H(\omega))\} )', ...
	'verticalalignment','baseline','fontsize',14)
xlabel('Frekvens,  (f Hz)     Grnsfrekvens f_0=1 Hz','fontsize',14)



else		% Anrop genom andring av gradtal (buttnr=1 eller 2)
		% eller genom val av filtertyp (buttnr=3 eller 4)

%global FILT, if strcmp(get(FILT(1),'String'),'Butterworth')

if buttnr>2,				% Om andrad filtertyp
  buttnr=buttnr-2;			% buttnr=1; andra bla, =2; andra rod
end
  filttyp=get(FILT(buttnr),'value');	% 1 => Butterworth,  2 => Chebyshev

val=get(BUTT(buttnr),'value')-1;	% val = valt gradtal (0 till 9)
if val==0,
  for a=1:9
	set(POL(buttnr,a),'visible','off')	% Osynliga poler
  end
  set(AMPLOT(buttnr),'visible','off')
  set(GRLP(buttnr),'visible','off')
else
  if filttyp==1				% Butterworthfilter
  	Htmp=butterw(val);
  else
	[b,a]=cheby1(val,3,2*pi,'s');	% Chebyshev I-filter
	Htmp=in(b,a,'s');
  end
  poler=po(Htmp);
  for a=1:9				% Gor poler synliga
    if a<=val
     	set(POL(buttnr,a),'XData',real(poler(a)),'YData',imag(poler(a)), ...
			  'visible','on')
    else
	set(POL(buttnr,a),'visible','off')
    end
  end
  [freq,amp,pha]=ampphase(Htmp,2.5);
  set(AMPLOT(buttnr),'YData',amp,'visible','on')
  lth=length(pha);
  phhopp=find(pha(1:lth-1)<pha(2:lth));
  for a=1:length(phhopp)
	pha(phhopp(a)+1:lth)=pha(phhopp(a)+1:lth)-360;	% Fixa bort alla
  end							% fashopp pa 360 gr
  set(GRLP(buttnr),'YData', -1/360*diff(pha)./diff(freq), ...
		   'visible','on')
end
end