function lineexp(action,Func,hand2);
% LINEEXP - Omskrivning av MathWorks sigdemo2.m
% lineexp(action,Func); 
%
%       possible actions: 'down' 'move' 'up'
%	Func = name of function which may ba called from lineexp
%	hand2 = handle to a plot related to the one to be changed
%
% Lasse Alfredsson, Aug-Sept 1997

global LINEEXP LINEXDATA LINEYDATA

%    LINEEXP = [xmin xmax ymin ymax fixed_x fixed_y line_handle ax];

%    set(gcf,'WindowButtonMotionFcn', sprintf('lineexp(''move'',%g)',in1));
%      Smart way of obtaining  ...Fcn','lineexp(''move'',N)')
%        where N needs to be the *number* N (=in1 here) 
%        and not the string 'N' (='in1')

if nargin==1, Func=''; hand2=[]; end	% Ingen funktion anropas

if strcmp(action,'down'),
    % assumes that a line was clicked 

    line_handle = gco;
    set(line_handle,'EraseMode','xor');
    ax = gca;
    axes(ax);

    % Obtain coordinates of mouse click location in axes units
    pt=get(gca,'currentpoint');
    x=pt(1,1);
    y=pt(1,2);

    % find closest point on line to mouse click loc (call it fixed_x, fixed_y)
    line_x=get(line_handle,'XData');
    line_y=get(line_handle,'YData');
    LINEXDATA=line_x;
    LINEYDATA=line_y;
    dist=(line_x-x).^2 + (line_y-y).^2;
    [temp,i]=min(dist);

%    set(line_handle,'LineStyle','--');	% Eller andra farg?
    drawnow;

    LINEEXP(1)=line_x(1);	% xmin
    LINEEXP(2)=line_x(length(line_x));	% xmax
    axudata=get(ax,'Userdata');
    if ~isempty(axudata)	% Begransning av andring i y-led
	LINEEXP(3)=axudata(1);	% ymin 
	LINEEXP(4)=axudata(2);  % ymax
    else			% Ingen begransning
	LINEEXP(3)=-Inf;	 
	LINEEXP(4)= Inf;
    end 
    LINEEXP(5)=line_x(i);	% fixed_x
    LINEEXP(6)=line_y(i);	% fixed_y
    LINEEXP(7)=line_handle;	% Handtag till aktuell linje
    LINEEXP(8)=ax;		% Handtag till aktuell axes

    set(gcf,'WindowButtonMotionFcn', ...
	sprintf('lineexp(''move'',''%s'',%19.16f)',Func,hand2));
    set(gcf,'WindowButtonUpFcn', ...
	sprintf('lineexp(''up'',''%s'',%19.16f)',Func,hand2));

    watchoff(gcf)

    eval([Func '(' sprintf('%19.16f,%19.16f,%19.16f',ax,line_handle,hand2) ')'])


elseif strcmp(action,'move'),
    xmin        = LINEEXP(1);
    xmax        = LINEEXP(2);
    ymin        = LINEEXP(3);
    ymax        = LINEEXP(4);
    fixed_x     = LINEEXP(5);
    fixed_y     = LINEEXP(6);
    line_handle = LINEEXP(7);
    ax          = LINEEXP(8);

    axes(ax)
    line_x=LINEXDATA;
    line_y=LINEYDATA;
    ampmax=max(line_y);
    ampmin=min(line_y);
    tidmin=line_x(1);
    tidmax=line_x(length(line_x));

    pt=get(gca,'currentpoint');
    x=pt(1,1);
    y=pt(1,2);

    yquot=y/fixed_y;	% Relativ andring i y-led
    ampnymax=ampmax*yquot;
    ampnymin=ampmin*yquot;
    if ampnymax>ymax | ampnymin<ymin, yquot=1; end

    axlim=axis;
    xquot=x/fixed_x;	% Relativ andring i x-led
    tidminny=tidmin*xquot;
    tidmaxny=tidmax*xquot;
%    if tidmaxny<axlim(2), xquot=axlim(2)/tidmax; end
%    if tidminny>axlim(1), xquot=axlim(1)/tidmin; end

    nyydata=line_y*yquot;
    nyxdata=line_x*xquot;
    set(line_handle,'YData',nyydata);
    set(line_handle,'XData',nyxdata);

    if min([ampnymax ymax])>axlim(4) | max([ampnymin ymin])<axlim(3)
% Andra axis om funktionen dras utanfor axis (i y-led)
%	axis([axlim(1:2) max([ampnymin ymin]) min([ampnymax ymax])])
    end
 
    eval([Func '(' sprintf('%19.16f,%19.16f,%19.16f',ax,line_handle,hand2) ')'])

 
elseif strcmp(action,'up'),
    xmin        = LINEEXP(1);
    xmax        = LINEEXP(2);
    ymin        = LINEEXP(3);
    ymax        = LINEEXP(4);
    fixed_x     = LINEEXP(5);
    fixed_y     = LINEEXP(6);
    line_handle = LINEEXP(7);
    ax          = LINEEXP(8);

    axes(ax)
    line_x=LINEXDATA;
    line_y=LINEYDATA;
    ampmax=max(line_y);
    ampmin=min(line_y);
    tidmin=line_x(1);
    tidmax=line_x(length(line_x));

    pt=get(gca,'currentpoint');
    x=pt(1,1);
    y=pt(1,2);

    yquot=y/fixed_y;	% Relativ andring i y-led
    ampnymax=ampmax*yquot;
    ampnymin=ampmin*yquot;
    if ampnymax>ymax | ampnymin<ymin, yquot=1; end

    axlim=axis;
    xquot=x/fixed_x;	% Relativ andring i x-led
    tidminny=tidmin*xquot;
    tidmaxny=tidmax*xquot;
%    if tidmaxny<axlim(2), xquot=axlim(2)/tidmax; end
%    if tidminny>axlim(1), xquot=axlim(1)/tidmin; end


    set(gcf,'WindowButtonMotionFcn','');
    set(gcf,'WindowButtonUpFcn','');

    set(line_handle,'linestyle','-');

    nyydata=line_y*yquot;
    nyxdata=line_x*xquot;
    set(line_handle,'YData',nyydata);
    set(line_handle,'XData',nyxdata);

    if min([ampnymax ymax])>axlim(4) | max([ampnymin ymin])<axlim(3)
% Andra axis om funktionen dras utanfor axis (i y-led)
%	axis([axlim(1:2) max([ampnymin ymin]) min([ampnymax ymax])])
    end
 
    drawnow;

    eval([Func '(' sprintf('%19.16f,%19.16f,%19.16f',ax,line_handle,hand2) ')'])


end
