function linemovex(action,Func,hand2);
% LINEMOVEX - Som baserad pa LINEEXP, men flyttar (*roterar*) funktionen bara i x-led
% 
% Lasse Alfredsson, Aug-Sept 1997

global LINEMOVE LINEY


if nargin==1, Func=''; hand2=[]; end	% Ingen funktion anropas

if strcmp(action,'down'),
    % assumes that a line was clicked 
    line_handle = gco;
    set(line_handle,'EraseMode','xor');
    ax = gca;
    axes(ax);

    % saves the original line in line UserData
    line_y=get(line_handle,'YData');
    if isempty(get(line_handle,'UserData'))
	set(line_handle,'UserData',[0 line_y]);
    end	% UserData(1)=total tidsforskjutning
	%UserData(2)=totala indexforskjutningen
	%UserData(3:resten)=original-linjen


    % Obtain coordinates of mouse click location in axes units
    pt=get(gca,'currentpoint');
    x=pt(1,1);

    % find closest x-point on line to mouse click loc (call it old_x)
    line_x=get(line_handle,'XData');
    dist=abs(line_x-x);
    [temp,i]=min(dist);

    set(line_handle,'LineStyle','--');	% Eller andra farg?
    drawnow;

    LINEMOVE(1)=line_x(i);	% old_x
    LINEMOVE(2)=line_handle;	% Handtag till aktuell linje
    LINEMOVE(3)=ax;		% Handtag till aktuell axes

    set(gcf,'WindowButtonMotionFcn', ...
	sprintf('linemovex(''move'',''%s'',%19.16f)',Func,hand2));
    set(gcf,'WindowButtonUpFcn', ...
	sprintf('linemovex(''up'',''%s'',%19.16f)',Func,hand2));

    watchoff(gcf)

    eval([Func '(' sprintf('%19.16f,%19.16f,%19.16f',ax,line_handle,hand2) ')'])


elseif strcmp(action,'move'),
    old_x       = LINEMOVE(1);
    line_handle = LINEMOVE(2);
    ax          = LINEMOVE(3);

    line_x=get(line_handle,'XData');
    line_y=get(line_handle,'YData');
    line_len=length(line_x);

    pt=get(gca,'currentpoint');
    x=pt(1,1);

    dist=abs(line_x-x);
    [temp,i]=min(dist);
    new_x=line_x(i);		% Det x som ligger narmast pt
    xmove=new_x-old_x;

    old_pos=find(line_x==old_x);
    new_pos=find(line_x==new_x);
    pos_move=new_pos-old_pos;

    orig_line=get(line_handle,'UserData');
%keyboard
    if abs(orig_line(2)+pos_move)<line_len/2	% = +/-(Max forskjutning)
      	if pos_move>0	% Flytta hoger
		ny_ydata=[line_y(line_len-pos_move:line_len) line_y(1:line_len-pos_move-1)];
    	else		% Flytta vanster
		ny_ydata=[line_y(pos_move+1:line_len) line_y(1:pos_move)];
    	end
    	set(line_handle,'UserData',[orig_line(1)+xmove orig_line(2)+pos_move orig_line(3:length(orig_line))]);
    	set(line_handle,'YData',ny_ydata);
    end

    eval([Func '(' sprintf('%19.16f,%19.16f,%19.16f',ax,line_handle,hand2) ')'])

 
elseif strcmp(action,'up'),
    old_x       = LINEMOVE(1);
    line_handle = LINEMOVE(2);
    ax          = LINEMOVE(3);


    line_x=get(line_handle,'XData');
    line_y=get(line_handle,'YData');
    line_len=length(line_x);

    pt=get(gca,'currentpoint');
    x=pt(1,1);


    dist=abs(line_x-x);
    [temp,i]=min(dist);
    new_x=line_x(i);		% Det x som ligger narmast pt
    xmove=new_x-old_x;

    old_pos=find(line_x==old_x);
    new_pos=find(line_x==new_x);
    pos_move=new_pos-old_pos;

    orig_line=get(line_handle,'UserData');
    if abs(orig_line(2)+pos_move)<line_len/2	% = +/-(Max forskjutning)
      	if pos_move>0	% Flytta hoger
		ny_ydata=[line_y(line_len-pos_move:line_len) line_y(1:line_len-pos_move-1)];
    	else		% Flytta vanster
		ny_ydata=[line_y(pos_move+1:line_len) line_y(1:pos_move)];
    	end
    	set(line_handle,'UserData',[orig_line(1)+xmove orig_line(2)+pos_move orig_line(3:length(orig_line))]);
    	set(line_handle,'YData',ny_ydata);
    end

    set(gcf,'WindowButtonMotionFcn','');
    set(gcf,'WindowButtonUpFcn','');

    set(line_handle,'linestyle','-');

    drawnow;

    eval([Func '(' sprintf('%19.16f,%19.16f,%19.16f',ax,line_handle,hand2) ')'])


end
