function lpidealdem(ind)
% approximation av ett idealt LP-filter, men kausalt.
%
% Lasse Alfredsson, Oktober 1997

global AX KAUSBUTT KAUS TSLIDER FUNCx PLHAND


t=linspace(-0.1,0.4,400);

if nargin==0	% Forsta anropet

axesdef(3,'Approximation av idealt, kausalt LP-filter');
  uimenu('Label','            ');
  fom = uimenu('Label','Brja om !!');
  	uimenu(fom, 'Label','G till KRETSDEMO', 'callback','clf, kretsdemo(1)');
        uimenu(fom, 'Label','Filterapproximering igen', 'callback','lpidealdem');

   axes(AX(1,1))
   currax=axis;
   axpos=get(gca,'position');
   KAUS='Icke kausal';
   KAUSBUTT=uicontrol('style','pushbutton','units','normal', ...
		'pos',[axpos(1) axpos(2)+axpos(4) .15 .04], ...
		'string','Icke kausal','fontsize',14, ...
		'callback','global KAUSBUTT KAUS, if strcmp(KAUS,''Kausal''), KAUS=''Icke kausal'';else KAUS=''Kausal'';end, set(KAUSBUTT,''String'',KAUS), lpidealdem(1)');

   deltax=0.03;
   deltay=0.03;
   TSLIDER=uicontrol('style','slider','units','normal', ...
		'pos',[axpos(1)+axpos(3)/5-deltax axpos(2)+axpos(4)-deltay 4*axpos(3)/5+2*deltax deltay], ...	
		'sliderstep',[0.02 0.1],'min',0,'max',.4,'value',0, ...
		'callback','lpidealdem(1)');
   x=in('2*80*sinc(2*80*(t-0))','t');
   X=foutr(x);
   PLHAND(1)=plot(t,2*80*sinc(2*80*(t-0)),'b','EraseMode','xor','linewidth',2);
   set(gca,'fontsize',14)
   axis([-.1 .4 -40 190])
   grid
   title('Impulssvar  (h(t) = 2f_0sinc(2f_0(t-\tau)) )')

   axes(AX(2,1))
   PLHAND(2)=spectmod(X,'A',100);
   set(PLHAND(2),'EraseMode','xor')
   title('Amplitudkaraktristik, |H(f)|')
   axis([0 100 0 1.2])

   axes(AX(2,2))
   PLHAND(3)=spectmod(X,'P',100);
   set(PLHAND(3),'EraseMode','xor')
   title('Faskaraktristik, arg(H(f))');

else
   axes(AX(1,1))
   slpos=get(TSLIDER,'value');
   if strcmp(KAUS,'Kausal')
	FUNCx=['2*80*sinc(2*80*(t-' num2str(slpos) '))*us(t)'];
	set(PLHAND(1),'YData',2*80*sinc(2*80*(t-slpos)).*us(t))
   	set(get(gca,'title'),'string', ...
		'Impulssvar  (h(t) = 2f_0sinc(2f_0(t-\tau))u(t) )');
   else
	FUNCx=['2*80*sinc(2*80*(t-' num2str(slpos) '))'];
	set(PLHAND(1),'YData',2*80*sinc(2*80*(t-slpos)))
   	set(get(gca,'title'),'string', ...
		'Impulssvar  (h(t) = 2f_0sinc(2f_0(t-\tau)) )');
   end

   
   x=in(FUNCx,'t');
   X=foutr(x);
   [freq, amp, phase]=ampphase(X,100);
   set(PLHAND(2),'YData',amp)
   set(PLHAND(3),'YData',phase)

end
