function output=maninp (defaults)

global numvectors;



%Function takes in defaults, which contains
%the default values for the type of graph
%requested.  It accepts modifications, and then
%passes the end matrix in proper form
%[Mag, Freq, Phase;...] to mc 

%Here is what each default value means:
%	1000	Own Inputs
%	2	cos x
%	3	cos x
%	4	sin x + cos x
%	5	odd harm to 1/3,3
%	6	odd harm to 1/5,5
%	7	odd harm to 1/7,7
%	8	odd harm to 1/23,23
%	9.?	Impulse train functions
%	10.?	Sawtooth functions

%***********************************************


%-----------------------------------------
%  To determine if we should keep
%  the maninput screen up.  If 
%  they have entered their own vectors,
%  we keep it up.  If the vectors were
%  part of a "canned" presentation, we
%  will close it.  The windows are closed
%  in the __?__ program.

if defaults==1000
	global KeepInput
	KeepInput=1;
elseif defaults~=1000
	global KeepInput
	KeepInput=1;	% LASSE ANDRADE FRAN 0 TILL 1 !!!!!!!!!!!!!!!!!!!
end			% => TAR INTE BORT FONSTRET VID RESP DEMO !!!!!!!

%----------------------------------------

if defaults==1000	%They've entered their
			%own number of vectors
			%and have gotten here
			%from the vnv.m program
	vnvfig=gcf;
	kids=get(vnvfig,'Children');
	stra=get(kids(2),'String');
	numvectors=str2num(stra);	
	close (vnvfig);
	Mag=ones(1,numvectors);
	Freq=ones(1,numvectors);
	Phase=zeros(1,numvectors);
	global Sample
	Sample=20;

end



%*****************************************************

%To find out how many vectors are necessary and
%to specify default values

if defaults==2

	numvectors=1;
	Mag(1)=1;
	Freq(1)=1;
	Phase(1)=90;

elseif defaults==3

	numvectors=1;
	Mag(1)=1;
	Freq(1)=1;
	Phase(1)=0;

elseif defaults==4

	numvectors=1;
	Mag(1)=1;
	Freq(1)=1;
	Phase(1)=130;

%-----------------------------------------------------------
%Here is the odd-harmonic section
elseif defaults==5 | defaults==6 | defaults==7 | defaults==8
	
	if defaults==5
		numvectors=2;		
	elseif defaults==6
		numvectors=3;
	elseif defaults==7
		numvectors=4;
	elseif defaults==8
		numvectors=12;
	end
	Mag=zeros(1,numvectors);
	Freq=zeros(1,numvectors);
	Phase=zeros(1,numvectors);
	for cf=1:numvectors
		Mag(cf)=1/((2*cf)-1);
		Freq(cf)=(2*cf)-1;

	end	%End of for loop assigning Mag and Freq

%------------------------------------------------------------

elseif defaults==9.03 | defaults==9.05 | defaults==9.08 | defaults==9.16

	numvectors=(defaults*100)-900;
	Mag=zeros(1,numvectors);
	Freq=zeros(1,numvectors);
	Phase=zeros(1,numvectors);
	Mag(1)=1;
	Freq(1)=0;
	Phase(1)=90;
	for cf=2:numvectors
		Mag(cf)=2;
		Phase(cf)=90;
		Freq(cf)=cf-1;
	end	

elseif defaults==10.03 | defaults==10.05 | defaults==10.08 | defaults==10.16

	numvectors=(defaults*100)-1000;
	Mag=zeros(1,numvectors);
	Freq=zeros(1,numvectors);
	Phase=zeros(1,numvectors);
	for cf=1:numvectors;
		Freq(cf)=cf;
		Mag(cf)=1/cf;
	end
	
end	%End of finding out defaults


%************************************************
% To define the Sampling Rates
%-----------------------------

% To set the Sample Rate
if defaults==2 | defaults==3 | defaults==4
	global Sample
	Sample=100;
elseif defaults==5
	global Sample
	Sample=20;
elseif defaults==6
	global Sample
	Sample=20;
elseif defaults==7
	global Sample
	Sample=12;
elseif defaults==8
	global Sample
	Sample= 6;
elseif defaults==9.03 | defaults==9.05 | defaults==9.08 | defaults==9.16
	global Sample
	Sample=14;
elseif defaults==10.03 | defaults==10.05 | defaults==10.08 | defaults==10.16
	global Sample;
	Sample=10;
end

%-------------------------------------------------------------------------------
% To define the title string in spot (1,1)

global TitleInfo
TitleInfo=zeros(4,3);
if defaults==1000 | (defaults>=2 & defaults<=4) | (defaults>=10 & defaults~=1000)
	
% This is for manual entry of vectors, the simple sins and coss, and the sawtoothes
% and the impulses
	TitleInfo(1,1)=numvectors;
elseif defaults>=5 & defaults<=8
% This is for the square wave approximations
	TitleInfo(1,1)=(2*numvectors)-1;
elseif defaults>=9 & defaults<10
% This is for the impulses
	TitleInfo(1,1)=numvectors-1;
end
%-------------------------------------------------------------------------------

%*************************************************

%To set up the screen
global ManInScreen

ManInScreen=figure ('MenuBar','none','Name','Phasor Values To Be Used',...
	'NumberTitle','off','Units','normalized',...
	'Position',[eps, .1, .75, .74],...
	'Color',[0 .4 .4]);
%***********************************************************************

LetsGraph=uimenu ('Label','Let''s &Graph');
P1=['global Periods,Periods=1;global TitleInfo,TitleInfo(2,1)=1;mnreader'];
P2=['global Periods,Periods=2;global TitleInfo,TitleInfo(2,1)=2;mnreader'];
P3=['global Periods,Periods=3;global TitleInfo,TitleInfo(2,1)=3;mnreader'];
P4=['global Periods,Periods=4;global TitleInfo,TitleInfo(2,1)=4;mnreader'];
	uimenu(LetsGraph,'Label','&1.  One Period','Callback',P1);
	uimenu(LetsGraph,'Label','&2.  Two Periods','Callback',P2);
	uimenu(LetsGraph,'Label','&3.  Three Periods','Callback',P3);
	uimenu(LetsGraph,'Label','&4.  Four Periods','Callback',P4);

Alter=uimenu('Label','&Drawing Style');

VF=['global Sample,Sample=8;'];
F=['global Sample,Sample=12;'];
A=['global Sample,Sample=20;'];
S=['global Sample,Sample=40;'];
VS=['global Sample,Sample=100'];
	uimenu(Alter,'Label','V&ery Fast','Callback',VF);
	uimenu(Alter,'Label','&Fast','Callback',F);
	uimenu(Alter,'Label','&Average','Callback',A);
	uimenu(Alter,'Label','&Smooth','Callback',S);
	uimenu(Alter,'Label','Very Sm&ooth','Callback',VS);


PhaseIt=uimenu('Label','&Phase Shift','CallBack','pslide');

Windowing=uimenu('Label','&Windowing');
	uimenu(Windowing,'Label','&Fejer Window','CallBack','window(1)');
	uimenu(Windowing,'Label','&Hamming Window','CallBack','window(2)');

global LablHnd
LablHnd=uimenu('Label','&Labels are On','CallBack','labeler(1)');
	TitleInfo(1,3)=1;


%****************************************************************************



%The captions will be frames, which do nothing

frame=uicontrol ('Style','frame','Units','normalized',...
	'Position',[.01,.01,.98,.98]);


%-----------------------------------------------

%To set up the screen with the text boxes


VC=['Phasor  ',13,'Number'];
VectCaption=uicontrol('Style','text','Units','normalized',...
	'Position',[.02,.87,.12,.07],'ForeGroundColor','k',...
	'HorizontalAlignment','left','String',VC);
MC=['Magnitude',13,'Values'];
MagCaption=uicontrol('Style','text','Units','normalized',...
	'Position',[.17,.87,.12,.07],'ForeGroundColor','k',...
	'String',MC);
FC=['Frequency',13,'Values'];
FreqCaption=uicontrol('Style','text','Units','normalized',...
	'Position',[.47,.87,.12,.07],'ForeGroundColor','k',...
	'String',FC);
PC=['Phase',13,'Values'];
PhaseCaption=uicontrol('Style','text','Units','normalized',...
	'Position',[.765,.87,.13,.07],'ForeGroundColor','k',...
	'String',PC);


%**********************************************

%This part sets up the rows of
%Mags, Freqs, and Phases

global MagInfo
global FreqInfo
global PhaseInfo

for row=1:numvectors

	VectCapt(row)=uicontrol('Style','text','Units','normalized',...
		'Position',[.02, 1-(.14+(row*.05)),.05,.04],...
		'ForeGroundColor','k','String',row);
	MagInfo(row)=uicontrol('Style','edit','String',rats (Mag(row)),...
		'Units','normalized','Position',[.18, 1-(.14+(row*.05)),.1,.04],...
		'BackGroundColor','w','ForeGroundColor','k' );
	FreqInfo(row)=uicontrol('Style','edit','String',rats (Freq(row)),...
		'Units','normalized','Position',[.48, 1-(.14+(row*.05)),.1,.04],...
		'BackGroundColor','w','ForeGroundColor','k' );
	PhaseInfo(row)=uicontrol('Style','edit','String',Phase(row),...
		'Units','normalized','Position',[.8, 1-(.14+(row*.05)),.05,.04],...
		'BackGroundColor','w','ForeGroundColor','k' );
	

end
%--------------------------------------------------------

