function sampldem(foo)

global AX pm1 KlabL SAMPLFREKV fsslider fsplhand FSHAND theta Xnhand xhand xrhand Xntit

if nargin==0
  clf
  axesdef(11,'Sampling och samplingsteoremet')

  uimenu('Label','            ');
  fom = uimenu('Label','Brja om !!');
  	uimenu(fom, 'Label','G till KRETSDEMO2', 'callback','clf, kretsdemo2(1)');
        uimenu(fom, 'Label','Faltningsteoremet igen', 'callback','sampldem');

  pm1='20*exp(-10*t)*sin(2*pi*10*t)*us(t)';
  SAMPLFREKV=80;
  fmax=50;

  axes(AX(1,1))
  x=in(pm1,'t');
  Xf=abs(swap(foutr(x)));
  f=Xf(KlabL+2)*(0:(KlabL-1))-Xf(KlabL+2)*KlabL/2;
  plot(f,Xf(1:KlabL),'b','EraseMode','xor');
%  currax=axis;
%  axis([currax(1:2) -0.2 currax(4)])
  axis([-fmax fmax -.2 1.05])
  set(gca,'xtick',[-fmax -30 -10 0 10 30 fmax])
  title('| H(f) |')
  xlabel('Frekvens,  f  [Hz]')
  grid
  hold on
  FSHAND=text(SAMPLFREKV/2,0.8,[' f_s/2 = ' int2str(round(SAMPLFREKV/2)) ' Hz'],'fontsize',14,'color','red');

  axes(AX(2,1))
  xn=sample(pm1,SAMPLFREKV);
  Xn=abs(foutr(xn))/SAMPLFREKV;  % OBS!! Amplitudnormerad !!!!!
%  Xn=Xn(1:2:length(Xn));	% Bara for att minska langden pa Xn (ej nodv.)
  Xnlen=length(Xn);
  Xn=[Xn(Xnlen/2+1:Xnlen) Xn Xn Xn(1:Xnlen/2)];	% Periodisk upprepning 3 ggr.
  Xnlen3=length(Xn);
  theta=3*(0:Xnlen3-1)/Xnlen3-1.5;
  Xnhand=plot(theta,Xn,'b','EraseMode','xor');
;  axis([-1.5 1.5 0 1.05])
  Xntit=title(['T \cdot | X[\theta] |   ( OBS! Amplitudnormerad! )   Hr r f_s = ' int2str(SAMPLFREKV) ' Hz'],'verticalalign','baseline');
  xlabel('Normerad frekvens, \theta')
  grid
  hold on

  axes(AX(1,2))
  signalmod(x,.4)
  xhand=get(gca,'children');
  axis([-.05 .4 -10 17])
  title('x(t)','verticalalign','baseline')
  xlabel('')
  hold on

  axes(AX(2,2))
  signalmod(xn,0.4*SAMPLFREKV);
  axis([-0.05*SAMPLFREKV 0.4*SAMPLFREKV -10 17])
  title(['x[n] - (T = ' num2str(round(1000/SAMPLFREKV)/1000) ' sek)'],'verticalalign','baseline')
  xlabel('')

  axes(AX(3,2))
  xr=pam(xn,SAMPLFREKV);
  signalmod(xr,.4)
  xrhand=get(gca,'children');
  axis([-.05 .4 -10 17])
  title('x_r(t) - ideal rekonstruktion','verticalalign','baseline')
  xlabel('')
  hold on

  OHfigure2
  axes(AX(1,1))
  fsplhand(1)=plot(-SAMPLFREKV/2*[1 1], [-1 2],'r','EraseMode','xor','linewidth',1.5);
  fsplhand(2)=plot( SAMPLFREKV/2*[1 1], [-1 2],'r','EraseMode','xor','linewidth',1.5);
  hold off
  axes(AX(2,1))
  fsplhand(3)=plot(-0.5*[1 1], [-1 1000],'r','EraseMode','xor','linewidth',1.5);
  fsplhand(4)=plot( 0.5*[1 1], [-1 1000],'r','EraseMode','xor','linewidth',1.5);
  hold off

  dy=0.028;
  dx=.012;
  axpos=get(AX(1,1),'position');
  fsslider=uicontrol('style','slider','units','normal', ...
	'pos',[axpos(1)+axpos(3)/2-dx axpos(2) axpos(3)/2+dx  dy], ...	
	'sliderstep',[0.02 0.1],'min',3,'max',0.9*fmax, ...
	'value',SAMPLFREKV/2, ...
	'callback','sampldem(1)');

else	% slidern (w_s) andras

  SAMPLFREKV=round(2*get(fsslider,'value'));
  set(fsplhand(1),'XData',-SAMPLFREKV/2*[1 1])
  set(fsplhand(2),'XData', SAMPLFREKV/2*[1 1])
  set(FSHAND,'position',[SAMPLFREKV/2 0.8 0], ...
	'string',[' f_s/2 = ' num2str(SAMPLFREKV/2) ' Hz'])
  set(Xntit,'string',['T \cdot | X[\theta] |   ( OBS! Amplitudnormerad! )   Hr r f_s = ' int2str(SAMPLFREKV) ' Hz']);


  xn=sample(pm1,SAMPLFREKV);
  Xn=abs(foutr(xn))/SAMPLFREKV;  % OBS!! Amplitudnormerad !!!!!
  Xnlen=length(Xn);
  Xn=[Xn(Xnlen/2+1:Xnlen) Xn Xn Xn(1:Xnlen/2)];	% Periodisk upprepning 3 ggr.
  set(Xnhand,'YData',Xn)

  axes(AX(1,2))
  x=in(pm1,'t');
  delete(xhand)
  signalmod(x,.4)
  xhand=get(gca,'children');
  title('x(t)','verticalalign','baseline')
  xlabel('')
  grid on

  axes(AX(2,2))
  signalmod(xn,0.4*SAMPLFREKV);
  axis([-0.05*SAMPLFREKV 0.4*SAMPLFREKV -10 17])
  title(['x[n] - (T = ' num2str(round(1000/SAMPLFREKV)/1000) ' sek)'],'verticalalign','baseline')
  xlabel('')

  axes(AX(3,2))
  xr=pam(xn,SAMPLFREKV);
  delete(xrhand)
  signalmod(xr,.4)
  xrhand=get(gca,'children');
  title('x_r(t) - ideal rekonstruktion','verticalalign','baseline')
  xlabel('')
  grid on

end